/********************************************************************************
|  CLASS:         TLS2118 - Getting Started with MPLAB C for PIC18
|  PROGRAM:       Lab2.c   
|  DESCRIPTION:   First MPLAB C18 project to test whether everything is working
|  REQUIREMENTS:  TLS2118.lib 
|                              
| 
|  REVISION HISTORY:
|  30 APR 2009    Rob Ostapiuk v1.0
********************************************************************************/
#include <p18cxxx.h>
#include "../TLS2118_LIB/P18F_LCD.h"
#include <stdlib.h>

#pragma config OSC=INTIO7, WDT=OFF, BOREN = ON, BORV = 1, LVP=OFF, PBADEN=OFF, XINST = OFF, MCLRE = ON

#define	LED1	LATDbits.LATD0
#define	SW2		PORTBbits.RB0        // ϥ p18f4520.h  PORTB 줸cwq

unsigned int	Key_Count = 0 ;
unsigned int	Loop_Count = 0 ; 
unsigned int	Key_BounceTime = 0 ;
unsigned int	Key_Hold = 0 ;

char			ASCII_Buffer[10] ;

//**************************************************************
//***
//***     Q MPLAB SIM n\AQStopwatch \q
//***     U Delay( ) bϥ 8MHz ɪɶ?
//***
//**************************************************************
 
void	SW_Delay(void)
{
	unsigned 	Delay_X , Delay_Y ;
	for ( Delay_X = 0 ; Delay_X < 8695 ; Delay_X ++)
	{
		Delay_Y += 1 ;	
	}
}

void main(void)
{
	OSCCONbits.IRCF = 0x07 ;		// Select INTOSC-8Mhz as clock source
									// ToDo : iHվ IRCF 줸ӳ]wu@Wv 
	ADCON1bits.PCFG = 0x0f ;
    OpenLCD();

    putrsLCD((const rom far char*)"Lab2 Loop: ");
	LCD_Set_Cursor(1,0) ;
	putrsLCD((const rom far char*)"     Key : ");

	LATD = 0x00 ;		// Turn Off all LEDs
    
    while(1)
	{
		SW_Delay();
		Loop_Count ++ ;

		/* 	----------------------------------------------------------------
			 SW2 ð De-bounce
			---------------------------------------------------------------*/
		if (!SW2 && !Key_Hold)				//	YB Key_Hold != 1
			{ 	
				Key_BounceTime ++ ;
				if ( Key_BounceTime >= 2 )
				{	Key_Count ++ ;
					Key_Hold = 1 ;	
				}
			} 
		else if ( SW2 && Key_Hold )			//	YO Key_Hold == 1 Bw}
			{
				Key_BounceTime -- ;
				if ( Key_BounceTime == 0 )
				Key_Hold = 0 ;
			}

			LCD_Set_Cursor(0,11);
			putrsLCD((const rom far char*)"      ");  // NnܼƦrmJť
			LCD_Set_Cursor(1,11);
			putrsLCD((const rom far char*)"      ");			

			LCD_Set_Cursor(0,11);				//	]w (Y,X)
			itoa(Loop_Count,ASCII_Buffer) ;     // itoa( ) Ʀ\? qBo?
			putsLCD(ASCII_Buffer) ;

			LCD_Set_Cursor(1,11);
			itoa(Key_Count,ASCII_Buffer) ;
			putsLCD(ASCII_Buffer) ;		
	}	
}
