/********************************************************************************
|  CLASS:         TLS2118 - Getting Started with MPLAB C for PIC18
|  PROGRAM:       Lab3.c   
|  DESCRIPTION:   First MPLAB C18 project to test whether everything is working
|  REQUIREMENTS:  TLS2118.lib 
|                              
| 
|  REVISION HISTORY:
|  30 APR 2009    Rob Ostapiuk v1.0
********************************************************************************/
#include <p18cxxx.h>
#include "TLS2118_LIB/P18F_LCD.h"
#include <stdlib.h>
#include <timers.h>

#pragma config OSC=INTIO7, WDT=OFF, BOREN = ON, BORV = 1, LVP=OFF, PBADEN=OFF, XINST = OFF, MCLRE = ON

#define	LED1				LATDbits.LATD0
#define	SW2					PORTBbits.RB0
#define	TIMER1_INT_FLAG		PIR1bits.TMR1IF
#define	TIMER1_1ms_VALUE 	// ]w 1mS _ɶ 		//	CPU runs @ 8Mhz , 2MHZ Fcy , 1ms = 1000 us

unsigned char	HH = 0 ;
unsigned char	MM = 0 ; 
unsigned char	SS = 0 ;
unsigned int	Timer1_Acc = 0 ;
unsigned char	FLAG_1ms ;

char			ASCII_Buffer[10] ;

void	HighISR(void) ;
void	Update_Time(void) ;
void	Update_LCD(void) ;
void	putDecLCD(unsigned char) ;

//**************************************************
//*                 m 3-1
//*  إ Timer1 _Vqಾ禡A_ɶ]w 1mS
//*  
//*  1. Q #pragma code 覡qX} 0x0008 Vqಾ
//*  2. wq TIMER1_1ms_VALUE  1mS ]w
//*
//**************************************************
#pragma	code	HighVector = 0x0008 
??
#pragma code
	
//**************************************************
//*                 m 3-2
//*  إ Timer1 _禡A_ɶ]w 1mS
//*  
//*  1. Q #pragma interrupt 覡qXuv_禡
//*  2. sJ TIMER1_1ms_VALUE  1mS ]w
//*  3. XMP]w
//*
//*  I: Timer1 sJȷ|@ǭIxsʧ@Ӧһ~t
//*        ЧQ MPLAB SIM + Stopwatch \వӳɶץ
//*
//**************************************************

#pragma interrupt HighISR nosave=section(".tmpdata")
??
#pragma code

void main(void)
{
	OSCCONbits.IRCF = 0x07 ;		// 	Select INTOSC-8Mhz as clock source
									// 	ToDo : iHվ IRCF 줸ӳ]wu@Wv 
	ADCON1bits.PCFG = 0x0f ;		//	Set all ADC multiplexed pins as digital mode
    OpenLCD();

    putrsLCD((const rom far char*)"Lab3 Int/Timer1 ");
	LCD_Set_Cursor(1,0) ;
	putrsLCD((const rom far char*)"Time= HH:MM:SS");

	INTCONbits.GIE = 1 ;
	INTCONbits.PEIE = 1 ;

	LATD = 0x00 ;		// Turn Off all LEDs

		WriteTimer1(TIMER1_1ms_VALUE);
		OpenTimer1(	TIMER_INT_ON & T1_16BIT_RW &\
					T1_SOURCE_INT & T1_PS_1_1 & \
					T1_OSC1EN_OFF & T1_SYNC_EXT_OFF ) ;
		
    
    while(1)
	{
		if (FLAG_1ms)
		{
			FLAG_1ms = 0 ;
			Timer1_Acc ++ ;
			if ( Timer1_Acc == 1000 )  // = 1 As LCD ɶ
			{
				Timer1_Acc = 0 ;
				Update_Time() ;
				Update_LCD() ;
			}
		}

	}	
}

void	Update_Time(void)
{
		SS ++ ;
		if ( SS == 60 )
		{
			SS = 0 ;
			MM ++ ;
			if ( MM == 60 )
			{
				MM = 0 ;
				HH ++ ;
				if ( HH == 12 )
				{	HH = 0 ;	}
			}
		}
}

void Update_LCD(void)
{
	LCD_Set_Cursor(1,6);
	putDecLCD(HH);
	LCD_Set_Cursor(1,9);
	putDecLCD(MM);
	LCD_Set_Cursor(1,12);
	putDecLCD(SS);
}

void putDecLCD(unsigned char Dec_Value)
{
	unsigned char	Temp_Dec ;
	Temp_Dec = (Dec_Value/10) + '0' ;
	putcLCD(Temp_Dec) ;
	Temp_Dec = (Dec_Value%10) + '0' ;
	putcLCD(Temp_Dec) ;
}